# Praktikumsblatt 6 - Messung+Auswertung

 
## Aufgabe 1 - Prometheus-Referenz-Exporter
Um Messinstrumente zu überprüfen und zu eichen sind Referenz-Messobjekte notwendig, mit den die Messinstrumente kalibriert werden können. Ein solches Referenz-Messobjekte für die Kalibirerung von Prometheus-Messungen wird Ihnen vom Exporter http://dh.docklab.de:8777/metrics zur Verfügung gestellt. Eine Beschreibung des Exporters und der zur Verfügung gestellten Referenz-Metriken finden Sie unter http://dh.docklab.de:8777/index.html .
Über http://dh.docklab.de:8777/metrics (bzw. http://dh-ipv6.docklab.de:8777/metrics) wird Ihnen für 7 fiktive CPUs die Referenzmetrik promrefexporter_cpu_seconds zur Verfügung gestellt.
Konkrete Aufgabe: Integrieren Sie diese Metrik als Target/Endpoint in Ihr Prometheus-System und testen Sie, ob Sie darauf zugreifen können.
Hinweis: Damit Sie problemlos mit IPv6 auf den Exporter zugreifen können, verwenden Sie die URL dh-ipv6.docklab.de , die über DNS ausschließlich zu einer IPv6-Adresse aufgelöst wird. Die URL dh.docklab.de wird über DNS sowohl zu einer IPv4 als auch zu einer IPv6-Adresse aufgelöst. Daher kann es beim Zugriff über dh.docklab.de zu Problemen kommen.
Greifen Sie über Ihr Prometheus-System auf die Referenzmetrik promrefexporter_cpu_seconds mit einem Range-Vektor zu. Mit welcher Abfrage machen Sie dies? Beschreiben Sie kurz Ihr Ergebnis (in Tabellenform).
 
## Aufgabe 2 - Messung+Auswertung
Im folgenden möchten wir die Metrik promrefexporter_cpu_seconds möglichst genau zu einem Grafana-Auslastungsgraphen für CPU1, ... CPU7 auswerten. Hierzu verwenden wir unter anderem die Funktionen rate und irate.
Experimentieren Sie - zunächst in Ihrem Prometheus-System - für die Darstellung der Auslastungsgraphen von  CPU1, ... CPU7 mit verschiedenen Parametern. Vergleichen Sie insbesondere die Ergebnisse, die Sie mit der Funktion rate und der Funktion irate erhalten.
Welche Abfragen verwenden Sie für Ihre Experimente?
Basierend auf Ihren Ergebnissen und Erfahrungen erstellen Sie ein Grafana-Dashboard Praktikumsblatt 6, in dem in einem Panel P1 für die Metrik promrefexporter_cpu_seconds möglichst genau die Auslastungsgraphen von CPU3, CPU5 und CPU8 angezeigt werden.
Erstellen Sie für Ihr Grafana-Dashboard Praktikumsblatt 6 ein zweites Panel P2, in dem für die Metrik promrefexporter_cpu_seconds möglichst genau die Auslastungsgraphen von CPU1 , CPU2 , CPU4 , CPU6 und CPU7 angezeigt werden.
Wir wissen, dass alle CPU-Auslastunggraphen Rechteckkurven sind. Diese möchten wir auch möglichst genau auf unserem Dashboard angezeigt bekommen. Sie haben bemerkt, dass dies nicht ganz trivial ist. Welche interessante oder überraschende Beobachtungen haben Sie gemacht? Diskutieren Sie die bei der Messung auftretenden Probleme. Treten diese Probleme bei allen Arten von Messungen auf? Was sind Ihre Experten-Empfehlungen, die Sie Ihren Kollegen mitgeben möchten?
